#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "dns.h"

int udp_port = 53;

int
format_packet (void *buffer, int maxlen, struct in_addr addr)
{
  struct dnsheaderrec *hdr;
  char *data;
  static char myquery[] = "\7version\4bind\0\0\20\0\3";

  hdr = (struct dnsheaderrec *) buffer;
  data = (char *) buffer + sizeof (struct dnsheaderrec);

  memset (hdr, 0, sizeof (struct dnsheaderrec));

  hdr->id = htons (0x321);
  hdr->qdcount = htons (1);

  memcpy (data, myquery, sizeof (myquery) - 1);

  return sizeof (struct dnsheaderrec) + sizeof (myquery) - 1;
}

int
received_packet (void *buffer, int len, struct in_addr addr)
{
  struct dnsheaderrec *hdr;
  char *data;
  char name[0x41];
  int nlen;

  hdr = (struct dnsheaderrec *) buffer;
  data = (char *) buffer + sizeof (struct dnsheaderrec);

  if (ntohs (hdr->ancount) != 1 || hdr->rcode != 0 || hdr->qr != 1)
    {
      printf ("%s <unknown>\n", inet_ntoa (addr));
      return 1;
    }

  data += 42;
  nlen = *data++;
  if (nlen > 0x40)
    nlen = 0x40;
  memcpy (name, data, nlen);
  name[nlen] = 0;
  printf ("%s %s\n", inet_ntoa (addr), name);

  return 1;
}
